% function [C, labels] = cat_with_labels (varargin)
%   Concatenate input arguments and also return a list of labels.

%% Copyright 2012 Soren Hauberg
%%
%% This program is free software: you can redistribute it and/or modify
%% it under the terms of the GNU General Public License as published by
%% the Free Software Foundation, either version 3 of the License, or
%% (at your option) any later version.
%%
%% This program is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%% GNU General Public License for more details.
%%
%% You should have received a copy of the GNU General Public License
%% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [C, labels] = cat_with_labels (varargin)
  C = cat (2, varargin {:});
  labels = [];
  for k = 1:nargin
    Nk = size (varargin {k}, 2);
    labels = cat (1, labels, k*ones(Nk, 1));
  end % for
end % function
